<template>
  <v-container fluid>
      
    <div>

      <!-- ORDER DIALOG -->

      <v-dialog v-model="orderDialog" max-width="900px">
        <v-btn color="primary" dark slot="activator" class="mb-2">Novo Pedido</v-btn>
        <v-card>
          
          <v-card-title>
            <span class="headline">Sobre o Cliente</span>
          </v-card-title>
          
          <v-card-text>
            <v-container wrap grid-list-md>
              <v-layout wrap>
                <v-flex xs12 sm6 md4>
                  <v-text-field required label="Cliente" v-model="editedOrder.name"></v-text-field>
                </v-flex>
                <v-flex xs12 sm6 md4>
                  <v-text-field auto-grow rows="1" multi-line label="Info do cliente" v-model="editedOrder.info"></v-text-field>
                </v-flex>
                <!-- <v-flex xs12 sm6 md4>
                  <v-menu
                    ref="menu"
                    :close-on-content-click="false"
                    v-model="menu"
                    transition="scale-transition"
                    offset-y
                    full-width
                    :nudge-right="40"
                    min-width="290px"
                    :return-value.sync="editedOrder.deadline"
                  >
                    <v-text-field
                      slot="activator"
                      label="Prazo do pedido"
                      v-model="editedOrder.deadline"
                      prepend-icon="event"
                      readonly
                    ></v-text-field>
                    <v-date-picker v-model="editedOrder.deadline" no-title scrollable>
                      <v-spacer></v-spacer>
                      <v-btn flat color="primary" @click="menu = false">Cancel</v-btn>
                      <v-btn flat color="primary" @click="$refs.menu.save(editedOrder.deadline)">OK</v-btn>
                    </v-date-picker>
                  </v-menu>
                </v-flex> -->
              </v-layout>
            </v-container>
          </v-card-text>
          
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue darken-1" flat @click.native="closeDialogs">Cancelar</v-btn>
            <v-btn color="blue darken-1" flat @click.native="saveOrder">Salvar</v-btn>
          </v-card-actions>
        
        </v-card>
      </v-dialog>

      <!-- ITEM DIALOG -->

      <v-dialog v-model="itemDialog" max-width="900px">
        <v-card>
          
          <v-card-title>
            <span class="headline">Novo Item</span>
          </v-card-title>
          
          <v-card-text>
            <v-container wrap grid-list-md>
              <v-layout wrap>
                <v-flex xs12 sm6 md4>
                  <v-text-field label="Item" v-model="editedItem.name"></v-text-field>
                </v-flex>
                <v-flex xs12 sm6 md4>
                  <v-text-field label="Quantidade" v-model="editedItem.quantity"></v-text-field>
                </v-flex>
                <v-flex xs12 sm6 md4>
                  <v-text-field multi-line rows="1" label="Obs" v-model="editedItem.description"></v-text-field>
                </v-flex>
              </v-layout>
            </v-container>
          </v-card-text>
          
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue darken-1" flat @click.native="closeDialogs">Cancelar</v-btn>
            <v-btn color="blue darken-1" flat @click.native="saveItem">Salvar</v-btn>
          </v-card-actions>
        
        </v-card>
      </v-dialog>

    <!-- ORDER -->

      <v-layout> 
        <v-flex offset-md2 md8 xs12>
          
          <template v-for="(order, i) in orders">
            
            <v-card :key="i">
            <v-layout class="clientInfo">
              
              <v-flex md5>
                <div style="display: flex;">
                  <h1 v-text="order.name"></h1>
                  <v-icon color="green" style="margin-left: 6px; margin-bottom: 3px;" v-if="isAllDone(order)">done</v-icon>
                </div>
                <br/>
                <v-edit-dialog style="height: 15px;"> 
                  <h2 v-text="order.info"></h2>        
                  <v-text-field
                    slot="input"
                    label="Edit"
                    v-model="order.info"
                    multi-line
                    rows="1"
                    counter
                    @blur="updateOrder(order, 'info')"
                  ></v-text-field>
                </v-edit-dialog>
              </v-flex>

              <span class="text-xs-center bold" style="font-size:18px; color:orange" v-text="order.deadline"></span>
              
              <v-flex class="text-xs-right" >
                <v-btn color="primary" flat @click="openItemDialog(order)" mb-2>Adicionar Produto</v-btn>
                <v-menu transition="slide-x-transition">
                    <v-btn icon slot="activator">
                      <v-icon>more_horiz</v-icon>
                    </v-btn>                  
                    <v-list>
                      <v-list-tile>
                        <v-btn icon class="mx-0" @click="editOrder(order)">
                          <v-icon color="">edit</v-icon>
                        </v-btn>
                        <v-btn icon class="mx-0" @click="deleteOrder(order)">
                          <v-icon color="">delete</v-icon>
                        </v-btn>
                      </v-list-tile>
                  </v-list>
                </v-menu>
              </v-flex>

            </v-layout>

          <!-- ITEMS -->

            <v-data-table
              :headers="headers"
              :items="getItems(order)"
              select-all
              hide-actions
              item-key="name"
              >

            <!-- HEADER -->

              <template slot="headers" slot-scope="props">
                <tr style="height: 30px;">
                  <th
                    v-for="header in props.headers"
                    :key="header.text"
                    v-text="header.text"
                    style="padding: 0; font-size: 13px; font-weight: 400"
                  >
                  </th>
                </tr>
              </template>

            <!-- ROWS -->

              <template slot="items" slot-scope="props">
                <tr @click="props.expanded = !props.expanded">
                  <td class="text-xs-center tdItem bold" v-text="props.item.name"></td>
                  <td class="text-xs-center tdItem" v-text="props.item.quantity"></td>
                  <td class="tdItem" style="display: flex;">
                    <v-checkbox color="green" :input-value="props.item.isDone" @click="() => { 
                      props.expanded = !props.expanded
                      props.item.isDone = !props.item.isDone; 
                      updateItem(props.item, order, 'isDone')}"></v-checkbox>
                  </td>
                </tr>
              </template>
              <template slot="expand" slot-scope="props">
                <v-edit-dialog style="min-width:0; padding: 5px"> 
                  <h2 style="margin:15px;" v-text="'Obs: ' + props.item.description"></h2>        
                  <v-text-field
                    slot="input"
                    label="Edit"
                    v-model="props.item.description"
                    multi-line
                    rows="1"
                    counter
                    @blur="updateItem(props.item, order, 'description')"
                  ></v-text-field>
                </v-edit-dialog>
              </template>
            </v-data-table>

            </v-card>
          
          </template>
        
        </v-flex>
    </v-layout>
  </div>

  </v-container>
</template>


<script>
import firebase from "firebase";
import firebaseConfig from "../../config/firebase";
const firebaseApp = firebase.initializeApp(firebaseConfig);

let db = firebaseApp.database();

export default {
  firebase: {
    orders: db.ref("orders")
  },

  data: () => ({
    itemDialog: false,
    orderDialog: false,
    actualOrderKey: "",
    headers: [
      { text: "Item", value: "item", sortable: false },
      { text: "Quantidade", value: "quantity" }
    ],
    editedIndex: -1,
    defaultOrder: {
      name: "",
      info: "",
      deadline: "",
      comments: []
    },
    defaultItem: {
      isDone: false,
      name: "",
      description: "",
      quantity: 0
    },
    editedOrder: {
      name: "",
      info: "",
      deadline: "",
      comments: []
    },
    editedItem: {
      isDone: false,
      name: "",
      description: "",
      quantity: 0
    }
  }),

  watch: {
    itemDialog(val) {
      val || this.closeDialogs();
    },
    orderDialog(val) {
      val || this.closeDialogs();
    }
  },

  created() {},

  methods: {
    //ITEM

    isAllDone(order) {
      try {
        const notDoneArray = Object.values(order.items).filter(item => {
          return !item.isDone;
        });
        return notDoneArray.length == 0;
      } catch (a) {
        return;
      }
    },

    openItemDialog(order) {
      this.actualOrderKey = order[".key"];
      this.itemDialog = true;
    },

    updateItem(item, order, elem) {
      const obj = {};
      obj[`/${order[".key"]}/items/${item.key}/${elem}`] = item[elem];
      this.$firebaseRefs.orders.update(obj);
    },

    saveItem() {
      const push = db
        .ref(`orders/${this.actualOrderKey}/items`)
        .push(this.editedItem);
      const obj = {};
      obj[`${this.actualOrderKey}/items/${push.key}/key`] = push.key;
      this.$firebaseRefs.orders.update(obj);
      this.closeDialogs();
    },

    getItems(order) {
      try {
        return Object.values(order.items);
      } catch (a) {
        return [];
      }
    },

    //ORDER

    updateOrder(order, elem) {
      const obj = {};
      obj[`${order[".key"]}/${elem}`] = order[elem];
      this.$firebaseRefs.orders.update(obj);
    },

    saveOrder() {
      this.$firebaseRefs.orders.push(this.editedOrder);
      this.closeDialogs();
    },

    deleteOrder(order) {
      const index = this.orders.indexOf(order);
      confirm("Quer mesmo deletar esse Pedido?") &&
        this.$firebaseRefs.orders.child(order[".key"]).remove();
    },

    //

    closeDialogs() {
      this.orderDialog = false;
      this.itemDialog = false;

      this.editedOrder = this.defaultOrder;
      this.editedItem = this.defaultItem;
      this.editedIndex = -1;
    }
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.clientInfo {
  margin: 12px;
  margin-left: 20px;
  margin-top: 25px;
  padding-top: 20px;
}
.bold {
  font-weight: bold;
}
h1 {
  font-size: 18px;
  font-weight: bold;
  margin: 0;
  padding: 0;
}
h2 {
  font-size: 15px;
  font-weight: normal;
  color: grey;
  margin: 0;
  padding: 0;
}
br {
  display: block;
  margin: 0 0;
  line-height: 2px;
  content: "";
}
.tdItem {
  font-size: 15px;
}
</style>
